/*
 *  TOPPERS/DeviceManager
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      DeviceManager
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *            Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 */

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include <shellapi.h>
#include "devicemanager.h"
#include <commctrl.h>

#include "devicemanager_i.c"
#include "device.h"
#include "information.h"
#include "kernel.h"
#include "kernellog.h"

#define WM_NOTIFYICONCALLBACK (WM_APP+1)	//NotifyIcon󂯎郁bZ[WɎgԍ
#define VERSION_TEXT "TOPPERS/DeviceManager  version2.0.1"

const DWORD dwTimeOut = 5000;  // EXEVbg_E܂ł̃AChԂł
const DWORD dwPause = 1000;    // XbhÎ҂Ԃł

HINSTANCE ProcessInstance = NULL;   //vZX̃CX^Xnh


// Vbg_E CxgĎp CreateThread ɓn܂
static DWORD WINAPI MonitorProc(void* pv)
{
    CExeModule* p = (CExeModule*)pv;
    p->MonitorShutdown();
    return 0;
}

LONG CExeModule::Unlock()
{
    LONG l = CComModule::Unlock();
    if (l == 0)
    {
        bActivity = true;
        SetEvent(hEventShutdown); // j^[Ƀ[ɕψڂƂ点܂
    }
    return l;
}

//Vbg_ECxgĎ܂
void CExeModule::MonitorShutdown()
{
    while (1)
    {
        WaitForSingleObject(hEventShutdown, INFINITE);
        DWORD dwWait=0;
        do
        {
            bActivity = false;
            dwWait = WaitForSingleObject(hEventShutdown, dwTimeOut);
        } while (dwWait == WAIT_OBJECT_0);
        // timed out
        if (!bActivity && m_nLockCnt == 0) // 삵Ă̂ȂΔo܂
        {
#if _WIN32_WINNT >= 0x0400 & defined(_ATL_FREE_THREADED)
            CoSuspendClassObjects();
            if (!bActivity && m_nLockCnt == 0)
#endif
                break;
        }
    }
    CloseHandle(hEventShutdown);
    PostThreadMessage(dwThreadID, WM_QUIT, 0, 0);
}

bool CExeModule::StartMonitor()
{
    hEventShutdown = CreateEvent(NULL, false, false, NULL);
    if (hEventShutdown == NULL)
        return false;
    DWORD dwThreadID;
    HANDLE h = CreateThread(NULL, 0, MonitorProc, this, 0, &dwThreadID);
    return (h != NULL);
}

CExeModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_Device, CDevice)
OBJECT_ENTRY(CLSID_Information, CInformation)
OBJECT_ENTRY(CLSID_Kernel, CKernel)
OBJECT_ENTRY(CLSID_KernelLog, CKernelLog)
END_OBJECT_MAP()


LPCTSTR FindOneOf(LPCTSTR p1, LPCTSTR p2)
{
    while (p1 != NULL && *p1 != NULL)
    {
        LPCTSTR p = p2;
        while (p != NULL && *p != NULL)
        {
            if (*p1 == *p)
                return CharNext(p1);
            p = CharNext(p);
        }
        p1 = CharNext(p1);
    }
    return NULL;
}

static void InsertAllDeviceMapList(HWND hList)
{
    _TCHAR buffer[64];
	_TCHAR num[16];
    std::map<Range, class DevMem *>::iterator mem_scope;
	std::list<class Mutex *>::iterator mut_scope;
	std::map<unsigned long, CKernel *>::iterator ker_scope;
    LVITEM item;
    int index;
	int length = 0;

    ListView_DeleteAllItems(hList);
    item.iItem = -1;

    EnterCriticalSection(&_Module.cs);

	//X[uƋLXgɒǉ
    mem_scope = _Module.AddressMap.begin();
    while(mem_scope != _Module.AddressMap.end()) {
		_TCHAR * strbuf;
		if(mem_scope->second->device != NULL){
			strbuf = (_TCHAR *)(BSTR)mem_scope->second->device->DeviceName;
		}else{
			strbuf = (_TCHAR *)(BSTR)(mem_scope->second->memory->bstr + " <Shared Memory>");
		}

	#ifndef _UNICODE
			length = WideCharToMultiByte(CP_ACP, 0, (BSTR)mem_scope->second->DeviceName, -1, 0, 0, NULL, NULL);
			if(length != 0) {
				strbuf = new _TCHAR [length + 1];
				WideCharToMultiByte(CP_ACP, 0, (BSTR)mem_scope->second->DeviceName, length, (char *)strbuf, length, NULL, NULL);
			}
			else
				strbuf = _T("<unknown>");
	#endif

        item.mask = LVIF_TEXT;
        ++ item.iItem;
        item.iSubItem = 0;
        item.pszText = strbuf;
        index = ListView_InsertItem(hList, &item);

		if(length != 0)
			delete [] strbuf;

        wsprintf(buffer, _T("0x%08X -- 0x%08X"), mem_scope->first.GetBase(), mem_scope->first.GetBase() + mem_scope->first.GetLength() - 1);
        ListView_SetItemText(hList, index, 3, buffer);
		if(mem_scope->second->device != NULL){
	        ListView_SetItemText(hList, index, 1, _T("process"));
		}else if(mem_scope->second->memory != NULL){
	        ListView_SetItemText(hList, index, 1, _T("memory"));
			_ltot( mem_scope->second->memory->GetCount(), num, 10 );
	        ListView_SetItemText(hList, index, 2, num);
		}else{
	        ListView_SetItemText(hList, index, 1, _T("unknown"));
		}

        ++ mem_scope;
    }

	//~[ebNXXgɒǉ
	mut_scope = _Module.MutexList.begin();
	while(mut_scope != _Module.MutexList.end()){
		_TCHAR * strbuf;
		int res;

		if((*mut_scope) == NULL || (BSTR)(*mut_scope)->bstr == NULL)
			continue;

		_ltot( (*mut_scope)->GetCount(), num, 10 );
		strbuf = (_TCHAR *)(BSTR)((*mut_scope)->bstr + " <Mutex>");
#ifndef _UNICODE
		length = WideCharToMultiByte(CP_ACP, 0, (BSTR)(*mut_scope)->bstr, -1, 0, 0, NULL, NULL);
		if(length != 0) {
			strbuf = new _TCHAR [length + 1];
			WideCharToMultiByte(CP_ACP, 0, (BSTR)(*mut_scope)->bstr, length, (char *)strbuf, length, NULL, NULL);
		}
		else
			strbuf = _T("<Mutex>");
#endif
		item.mask = LVIF_TEXT;
		++ item.iItem;
		item.iSubItem = 0;
		item.pszText = strbuf;
		index = ListView_InsertItem(hList, &item);

		if(length != 0)
			delete [] strbuf;

        ListView_SetItemText(hList, index, 2, num);
		if((*mut_scope)->hMutex != NULL){
			res = ::WaitForSingleObject((*mut_scope)->hMutex, 0);
			if(res == WAIT_TIMEOUT){
		        ListView_SetItemText(hList, index, 3, _T("in use"));
			}else{
		        ListView_SetItemText(hList, index, 3, _T("free"));
			}
			::ReleaseMutex((*mut_scope)->hMutex);
		}

		++ mut_scope;
	}

	//J[l}bvXgɒǉ
	ker_scope = _Module.KernelMap.begin();
	while(ker_scope != _Module.KernelMap.end()){
		TCHAR strbuf[256];

		item.mask = LVIF_TEXT;
		++ item.iItem;
		item.iSubItem = 0;
		item.pszText = _T("<Kernel>");
		index = ListView_InsertItem(hList, &item);
		_itot(ker_scope->first, strbuf, 10);
        ListView_SetItemText(hList, index, 3, strbuf);

		++ ker_scope;
	}

    LeaveCriticalSection(&_Module.cs);
}



INT CALLBACK MemoryMapDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg) {
        case WM_INITDIALOG:
            {
                LVCOLUMN col;

                HWND hList = GetDlgItem(hDlg, IDC_MAPLIST);
                
                col.mask = LVCF_TEXT|LVCF_WIDTH|LVCF_FMT;
                col.fmt = LVCFMT_LEFT;
                col.pszText = _T("foCX");
                col.cx = 200;
                ListView_InsertColumn(hList, 0, &col);

                col.mask = LVCF_TEXT|LVCF_SUBITEM|LVCF_WIDTH|LVCF_FMT;
                col.pszText = _T("vZX/");
                col.iSubItem = 1;
                col.cx = 30;
                ListView_InsertColumn(hList, 1, &col);

                col.mask = LVCF_TEXT|LVCF_SUBITEM|LVCF_WIDTH|LVCF_FMT;
                col.pszText = _T("QƐ");
                col.iSubItem = 2;
                col.cx = 30;
                ListView_InsertColumn(hList, 2, &col);

                col.mask = LVCF_TEXT|LVCF_SUBITEM|LVCF_WIDTH|LVCF_FMT;
                col.pszText = _T("AhX͈");
                col.iSubItem = 3;
                col.cx = 170;
                ListView_InsertColumn(hList, 3, &col);

                InsertAllDeviceMapList(hList);

                break;
            }

        case WM_COMMAND:
            switch(wParam) {
                case IDOK:
                    DestroyWindow(hDlg);
                    break;
                default:
                    FALSE;
            }
            break;

        case WM_CLOSE:
            DestroyWindow(hDlg);
            break;

        default:
            return FALSE;
    }

    return TRUE;
}

void ShowVersionDialog(HWND hParent)
{
	MessageBox(hParent, _T(VERSION_TEXT), _T("TOPPERS/DeviceManager o[W"), MB_OK);
}

void ShowMemoryMapDialog(HWND hParent)
{
    HWND hDlg = CreateDialog(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDD_MAPLISTDIALOG), hParent, MemoryMapDialogProc);
    ShowWindow(hDlg, SW_SHOW);
}


//---------------------------------------------------------------------
// NotifyIcon ReLXgj[
INT DummyDialogContextMenu(HWND hDlg)
{
	enum tagMenuID {
		IDM_EXIT = 1,
        IDM_MAPLIST = 2,
		IDM_VERSION = 3
	};

	_TCHAR buffer[128];

	HMENU hMenu = CreatePopupMenu();
	if(hMenu == NULL)
		return 0;

	wsprintf(buffer, _T("ڑ}X^ : %d"), _Module.KernelList.size());
	InsertMenu(hMenu, -1, MF_BYPOSITION|MF_STRING, 0, buffer);
	wsprintf(buffer, _T("ڑfoCX : %d"), _Module.DeviceList.size());
	InsertMenu(hMenu, -1, MF_BYPOSITION|MF_STRING, 0, buffer);
	wsprintf(buffer, _T("tς݋Ԑ : %d"), _Module.AddressMap.size());
	InsertMenu(hMenu, -1, MF_BYPOSITION|MF_STRING, 0, buffer);
	wsprintf(buffer, _T("ڑEHb` : %d"), _Module.WatcherList.size());
	InsertMenu(hMenu, -1, MF_BYPOSITION|MF_STRING, 0, buffer);
	InsertMenu(hMenu, -1, MF_BYPOSITION|MF_SEPARATOR, 0, NULL);
	InsertMenu(hMenu, -1, MF_BYPOSITION|MF_STRING,    IDM_MAPLIST, _T("}bv\"));
	InsertMenu(hMenu, -1, MF_BYPOSITION|MF_STRING,    IDM_VERSION, _T("o[W"));
	InsertMenu(hMenu, -1, MF_BYPOSITION|MF_STRING,    IDM_EXIT,    _T("I"));

	POINT curpos = {0,0};
	GetCursorPos(&curpos);

	int cmd = TrackPopupMenu(hMenu, TPM_RIGHTALIGN|TPM_BOTTOMALIGN|TPM_RETURNCMD|TPM_RIGHTBUTTON, curpos.x, curpos.y, 0, hDlg, NULL);

	switch(cmd) {
	case IDM_EXIT:
		PostQuitMessage(0);
		break;
	case IDM_VERSION:
		ShowVersionDialog(hDlg);
		break;
    case IDM_MAPLIST:
        ShowMemoryMapDialog(hDlg);
        break;
	default:
		break;
	}

	return cmd;
}


//---------------------------------------------------------------------
// NotifyIconp̃_~[_CAO bZ[Wnh
INT CALLBACK DummyDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {

	case WM_NOTIFYICONCALLBACK:
		switch(lParam) {
		case WM_RBUTTONUP:
			DummyDialogContextMenu(hDlg);
			break;
		default:
			return FALSE;
		}
		break;

	case WM_INITDIALOG: 
		{
				/* ^XNgCɃACRo^ */
			NOTIFYICONDATA nd;
			HICON hIcon = LoadIcon(ProcessInstance, MAKEINTRESOURCE(IDI_ICON1));
			nd.cbSize = sizeof(nd);
			nd.hWnd = hDlg;
			nd.uID = 100;
			nd.uFlags = NIF_ICON|NIF_MESSAGE|NIF_TIP;
			nd.hIcon = hIcon;
			nd.uCallbackMessage = WM_NOTIFYICONCALLBACK;
			::lstrcpy(nd.szTip, _T("TOPPERS DeviceManager"));
			Shell_NotifyIcon(NIM_ADD, &nd);

			break;
		}

	case WM_DESTROY:
		{
			NOTIFYICONDATA nd;
			nd.cbSize = sizeof(nd);
			nd.hWnd = hDlg;
			nd.uID = 100;
			nd.uFlags = 0;
			Shell_NotifyIcon(NIM_DELETE, &nd);
			break;
		}

	default:
		return FALSE;
	}

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
//
extern "C" int WINAPI _tWinMain(HINSTANCE hInstance, 
    HINSTANCE /*hPrevInstance*/, LPTSTR lpCmdLine, int /*nShowCmd*/)
{
    lpCmdLine = GetCommandLine(); // ̍s _ATL_MIN_CRT ̂߂ɕKvł
    
#if _WIN32_WINNT >= 0x0400 & defined(_ATL_FREE_THREADED)
    HRESULT hRes = CoInitializeEx(NULL, COINIT_MULTITHREADED);
#else
    HRESULT hRes = CoInitialize(NULL);
#endif
    _ASSERTE(SUCCEEDED(hRes));
    _Module.Init(ObjectMap, hInstance, &LIBID_ATLDEVICEMANAGERLib);
    _Module.dwThreadID = GetCurrentThreadId();
    TCHAR szTokens[] = _T("-/");

    int nRet = 0;
    BOOL bRun = TRUE;
    LPCTSTR lpszToken = FindOneOf(lpCmdLine, szTokens);
    while (lpszToken != NULL)
    {
        if (lstrcmpi(lpszToken, _T("UnregServer"))==0)
        {
            _Module.UpdateRegistryFromResource(IDR_ATLDeviceManager, FALSE);
            nRet = _Module.UnregisterServer(TRUE);
            bRun = FALSE;
            break;
        }
        if (lstrcmpi(lpszToken, _T("RegServer"))==0)
        {
            _Module.UpdateRegistryFromResource(IDR_ATLDeviceManager, TRUE);
            nRet = _Module.RegisterServer(TRUE);
            bRun = FALSE;
            break;
        }
        lpszToken = FindOneOf(lpszToken, szTokens);
    }

    if (bRun)
    {
		HWND dummy_dialog_handle = NULL;

		//::AllocConsole();

		ProcessInstance = hInstance;
		dummy_dialog_handle = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DUMMYDIALOG), NULL, DummyDialogProc);
		ShowWindow(dummy_dialog_handle, SW_HIDE);

        _Module.StartMonitor();
#if _WIN32_WINNT >= 0x0400 & defined(_ATL_FREE_THREADED)
        hRes = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER, 
            REGCLS_MULTIPLEUSE | REGCLS_SUSPENDED);
        _ASSERTE(SUCCEEDED(hRes));
        hRes = CoResumeClassObjects();
#else
        hRes = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER, 
            REGCLS_MULTIPLEUSE);
#endif
        _ASSERTE(SUCCEEDED(hRes));

        MSG msg;
        while (GetMessage(&msg, 0, 0, 0))
            DispatchMessage(&msg);

        _Module.RevokeClassObjects();
        Sleep(dwPause); //XbhI܂ő҂܂

		if(dummy_dialog_handle != NULL)
			::DestroyWindow(dummy_dialog_handle);

		::FreeConsole();
	}

    _Module.Term();
    CoUninitialize();
    return nRet;
}
