/*
 *  TOPPERS/DeviceManager
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      DeviceManager
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *            Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 *  @(#) $Id: stdafx.h,v 1.5 2003/12/24 07:40:42 takayuki Exp $
 */

#if !defined(AFX_STDAFX_H__4015F3E9_0639_43DE_A5EE_C32ECAFDFC74__INCLUDED_)
#define AFX_STDAFX_H__4015F3E9_0639_43DE_A5EE_C32ECAFDFC74__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define STRICT
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0400
#endif
#define _ATL_APARTMENT_THREADED

#pragma warning(push)
#pragma warning(disable:4786)

#include <list>
#include <map>
#include "range.h"
#include "messages.h"
#include "sharedmem.h"
#include "mutex.h"

typedef unsigned long DeviceID;
typedef unsigned long KernelID;
/*
typedef struct{
	enum {DEVICE,SMEMORY} type;
	union{
		class CDevice *dev;
		class SharedMem *mem;
	} target;
} DevMem;
*/
class DevMem
{
public:
	DevMem(class CDevice * dev)
		: device(dev), memory(NULL)
	{	}
	DevMem(class SharedMem * mem)
		: device(NULL), memory(mem)
	{	}

	class CDevice * device;
	class SharedMem * memory;
};

#include <atlbase.h>
// CComModule NXhNXgpāAI[o[Chꍇ
// _Module ̖O͕ύXȂłB
class CExeModule : public CComModule
{
public:
	bool GetMemory(BSTR lpName, unsigned long * address, unsigned long * size);
	BSTR CreateMutex(unsigned long number, class CKernel * kernel);
	BSTR CreateMutex(unsigned long number, class CDevice * device);
	void CloseMutex(unsigned long number, class CKernel * kernel);
	void CloseMutex(unsigned long number, class CDevice * device);
	bool ReleaseLock(unsigned long address, unsigned long size);
	bool AcquireLock(unsigned long address, unsigned long size);
	//void ReleaseLock(unsigned long address, unsigned long size, bool * res);
	//void AcquireLock(unsigned long address, unsigned long size, bool * res);
	//bool ReleaseSharedMemory2(unsigned long address);
	BSTR CreateSharedMemoryAnyName(class CKernel * kernel, unsigned long address, unsigned long size);
	BSTR CreateSharedMemoryAnyName(class CDevice * device, unsigned long address, unsigned long size);
	bool ReleaseSharedMemory(class CKernel * kernel, BSTR lpName);
	bool ReleaseSharedMemory(class CDevice * device, BSTR lpName);
	bool CreateSharedMemory(class CKernel * kernel, unsigned long address, unsigned long size, BSTR lpName);
	bool CreateSharedMemory(class CDevice * device, unsigned long address, unsigned long size, BSTR lpName);
	//bool CreateSharedMemory(DWORD size, BSTR lpName);
	bool OnLogEvent(class CKernel * kernel, long sz, unsigned char * data);
	void RemoveLogWatcher(class CKernelLog * watcher);
	bool AddLogWatcher(class CKernelLog * watcher);
	bool RaiseInterrupt(unsigned long inhno);
	bool Write(class CKernel * kernel, unsigned long address, unsigned long sz, unsigned char data[]);
	bool Read(class CKernel * kernel, unsigned long address, unsigned long sz, unsigned char data[]);
	bool UnmapKernel(class CKernel * kernel, unsigned long id);
	bool MapKernel(class CKernel * kernel, unsigned long id);
	bool DetachKernel(class CKernel * kernel);
	bool AttachKernel(class CKernel * kernel);
	bool DeleteKernel(class CKernel * kernel);
	KernelID AddKernel(class CKernel * kernel);
	void RemoveViewer(class CInformation * view);
	void AddViewer(class CInformation * view);
	bool Unmap(class CDevice * device, unsigned long address);
	bool Map(class CDevice * device, Range map);
	bool DeleteDevice(class CDevice * device);
	DeviceID AddDevice(class CDevice * device);

		//ɍꂽ
	LONG Unlock();
	DWORD dwThreadID;
	HANDLE hEventShutdown;
	void MonitorShutdown();
	bool StartMonitor();
	bool bActivity;


		//ō
	CRITICAL_SECTION cs;

	std::map<unsigned long, class CKernel *> KernelMap;
	std::list<class CKernel *> KernelList;
	std::map<Range, DevMem *> AddressMap;
	std::list<class CDevice *> DeviceList;
	std::list<class SharedMem *> SharedMemList;
	std::list<class CInformation *> ViewerList;
	std::list<class CKernelLog *> WatcherList;
	std::map<Range, class SharedMem *> LockList;
	std::list<class Mutex *> MutexList;
	
	CExeModule(void);
	
};
extern CExeModule _Module;
#include <atlcom.h>

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#pragma warning(pop)

#endif // !defined(AFX_STDAFX_H__4015F3E9_0639_43DE_A5EE_C32ECAFDFC74__INCLUDED)
